- block:
  - name: install metallb
    command: "kubectl apply -f {{ item }}"
    changed_when: False
    with_items: "{{ metallb_manifests }}"

  - name: get secrets in metallb-system namespace
    command: kubectl get secret -n metallb-system -o json
    changed_when: False
    register: kubectl_secrets

  - name: create memberlist secret unless it exists
    shell: kubectl create secret generic -n metallb-system memberlist --from-literal=secretkey="$(openssl rand -base64 128)"
    changed_when: False
    when: '"memberlist" not in secrets'

  - name: install metallb config.yaml manifest
    command: kubectl apply -f -
    args:
      stdin: "{{ lookup('template', 'templates/metallb/config.yaml') }}"
    changed_when: False

  vars:
    secrets_data: "{{ kubectl_secrets.stdout | from_json }}"
    secrets: "{{ secrets_data | json_query('items[*].metadata.name') }}"

  tags: metallb

  rescue:
    - debug:
        msg: "secrets: {{ secrets | default('') }}"
